"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.email = void 0;
const helper_1 = require("./helper");
const form_data_1 = __importDefault(require("form-data"));
const mailgun_js_1 = __importDefault(require("mailgun.js"));
class email extends helper_1.helper {
    constructor(engine = 'mailgun', param) {
        super(); //to call constructor dari base_helper
        if (engine == 'mailgun' || engine == "") {
            let engine = new mailgun_js_1.default(form_data_1.default);
            this.emailer = engine.client({ username: 'api', key: param.secret });
        }
    }
    // Mailgun
    mailgun_send(param) {
        return __awaiter(this, void 0, void 0, function* () {
            let results = {
                status: 0,
                data: null
            };
            this.emailer.messages.create(param.domain, {
                from: param.from,
                to: param.to,
                subject: param.subject,
                text: param.text, //'Testing some Mailgun awesomeness!'
            })
                .then((res) => {
                results.status = 1;
                results.data = res;
            })
                .catch((err) => {
                results.status = 0;
                results.data = err;
            });
            return results;
        });
    }
}
exports.email = email;
