"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.guardian = void 0;
// Native
const crypto_1 = __importDefault(require("crypto"));
// Helper
const helper_1 = require("./helper");
const codex_helper_1 = require("./codex.helper");
// Vendor
const speakeasy = __importStar(require("speakeasy"));
class guardian extends helper_1.helper {
    totp_secret() {
        const secret = speakeasy.generateSecret();
        return secret.base32;
    }
    totp(secret) {
        const otp = speakeasy.totp({
            secret: secret,
            encoding: "base32",
        });
        return otp;
    }
    _totp_secret() {
        const c = new codex_helper_1.codex();
        const random = crypto_1.default.randomBytes(20);
        const secret = c.base32_encode(random);
        return secret;
    }
    _totp(secret, timeStepSeconds = 30, codeDigits = 6) {
        // Calculate the current Unix time in seconds
        const currentUnixTime = Math.floor(Date.now() / 1000);
        // Calculate the counter value
        const counter = Math.floor(currentUnixTime / timeStepSeconds);
        // Convert the counter to a binary buffer
        const counterBuffer = Buffer.alloc(8);
        counterBuffer.writeBigInt64BE(BigInt(counter), 0);
        // Calculate the HMAC-SHA1 hash
        const hmac = crypto_1.default.createHmac("sha1", secret); //Buffer.from(secret, "base32")
        const hash = hmac.update(counterBuffer).digest();
        // Extract the offset from the last 4 bits
        const offset = hash[hash.length - 1] & 0x0f;
        // Extract the 4-byte binary code starting from the offset
        const binaryCode = hash.readUInt32BE(offset) & 0x7fffffff;
        // Calculate the final OTP by taking modulo 10^codeDigits
        const otp = (binaryCode % Math.pow(10, codeDigits))
            .toString()
            .padStart(codeDigits, "0");
        return otp;
    }
}
exports.guardian = guardian;
